import 'package:flutter/material.dart';
import 'package:orderable_stack/orderable_stack.dart';

void main() {
  runApp(new MaterialApp(home: new Scaffold(body: new ReorderDemo())));
}

class ReorderDemo extends StatefulWidget {
  @override
  _ReorderDemoState createState() => new _ReorderDemoState();
}

class _ReorderDemoState extends State<ReorderDemo> {
  List<Task> tasks = [
    new Task(1, 'task 1'),
    new Task(2, 'task 2'),
    new Task(3, 'task 3'),
    new Task(4, 'task 4'),
    new Task(5, 'task 5'),
  ];

  @override
  Widget build(BuildContext context) {
    return new Center(
      child: new OrderableStack<Task>(
        items: tasks,
        direction: Direction.Vertical,
        itemSize: const Size(200.0, 50.0),
        itemBuilder: orderableTaskBuilder,
      ),
    );
  }

  Widget orderableTaskBuilder({Orderable<Task> data, Size itemSize}) {
    return new Container(
      width: itemSize.width,
      height: itemSize.height,
      child: new Text(data.value.title),
    );
  }

  Widget itemBuilder({Orderable<Task> data, Size itemSize}) {
    return new Container(
      width: itemSize.width,
      height: itemSize.height,
      child: new Text(data.value.title),
    );
  }

}

class Task {
  final int order;
  final String title;

  Task(this.order, this.title);

  @override
  String toString() {
    return 'Task{order: $order, title: $title}';
  }

}
